import LSystem
import Test.QuickCheck

--Rainbow Spiral
--Rainbow Spiral

spiralX :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX x _ 0 _ _  = Sit
spiralX x (GrabPen (Colour 1 0 b)) y z q  |b <0 = spiralX1 x  (GrabPen (Colour  1 0 0 )) y z q 
                                          |otherwise =  GrabPen (Colour 1 0 b) :#:  Go x :#: Turn q :#: spiralX (x+z)  (GrabPen (Colour  1 0 (b-0.001) )) (y-1) z q

spiralX1 :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX1 x _ 0 _ _ = Sit 
spiralX1 x (GrabPen (Colour  1 g 0 )) y z q |g > 1 = spiralX2 x  (GrabPen (Colour  1 1 0 )) y z q   
                                            | otherwise =  GrabPen (Colour 1 g 0 ) :#:  Go x :#: Turn q :#:  spiralX1 (x+z)  (GrabPen (Colour  1 (g+0.001) 0 )) (y-1) z q   

spiralX2 :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX2 x _ 0 _ _ = Sit 
spiralX2 x (GrabPen (Colour  r 1 0 )) y z q | r < 0  =   spiralX3 x  (GrabPen (Colour  0 1 0)) y z q 
                                            | otherwise =  GrabPen (Colour r 1 0 ) :#:  Go x :#: Turn q :#: spiralX2 (x+z)  (GrabPen (Colour  (r-0.001) (1) 0 )) (y-1) z q   

spiralX3 :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX3 x _ 0 _ _ = Sit 
spiralX3 x (GrabPen (Colour  0 1 b )) y z q | b > 1 =   spiralX4 x  (GrabPen (Colour  0 1 1)) y z q 
                                            | otherwise =   GrabPen (Colour 0 1 b ) :#:  Go x :#: Turn q :#: spiralX3 (x+z)  (GrabPen (Colour  0 (1) (b+0.001) )) (y-1) z q   

spiralX4 :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX4 x _ 0 _ _ = Sit
spiralX4 x (GrabPen (Colour  0 g 1 )) y z q | g < 0  =  spiralX5 x  (GrabPen (Colour  0 0 1)) y z q
                                            | otherwise =  GrabPen (Colour 0 g 1 ) :#:  Go x :#: Turn q :#: spiralX4 (x+z)  (GrabPen (Colour  0 (g-0.001) 1 )) (y-1) z q   

spiralX5 :: Distance -> Command  -> Int -> Distance -> Angle -> Command
spiralX5 x _ 0 _ _ = Sit
spiralX5 x (GrabPen (Colour  r 0 1 )) y z q | r > 1  = spiralX x  (GrabPen (Colour 1 0 1))  y z q 
                                            | otherwise =  GrabPen (Colour r 0 1 ) :#:  Go x :#: Turn q :#:  spiralX5 (x+z)  (GrabPen (Colour  (r+0.001) (0) 1 )) (y-1) z q 

shapeR ::Command 
shapeR = spiralX 0.1 (GrabPen (Colour 1 0 1 )) 10000  0.1 4
